program test
 
!===========================================================
! ACT 3-year lensing likelihood code
! J. Dunkley, S. Das, B. Sherwin, R. Hlozek Jan 2013. 
! Based on WMAP likelihood codes.
!===========================================================

  use actlens_3yr_like

  integer,parameter   :: l_lens =2100
  character(LEN=128)  :: filename
  real(8)             :: cl_dd(2:l_lens),dum_r,like
  integer             ::il,dum_i
  
  call ACT_LIKELENS_INIT

  filename = 'data/test_cls.dat' !file is of CAMB output format
  write(*,*)"Reading in Cls from: ",trim(filename)

  call get_free_lun( lun )

  
  open(unit=lun,file=filename,action='read',status='old')
 
  cl_dd=0.d0
  do il=2,l_lens
     read(lun,*) dum_i, dum_r, dum_r, dum_r,cl_dd(il),dum_r
     cl_dd(il)=cl_dd(il)/(4.d0*(2.7255d6)**2) !convert to l^2C_dd/4
  enddo
  close(lun)
  like=0.d0

  call act_likelens_compute(cl_dd,like)
  
  write(*,*)"  "
  write(*,*)"----------------------------------------"
  write(*,*)"ACT lensing -2ln(L)              = ",2*like, "for 5 bins"
  write(*,*)"----------------------------------------"
  write(*,*)"Expected -2ln(L)                 =   0.758763514356822"
  write(*,*)"----------------------------------------"    
  write(*,*)"  " 
  
end program test
